#ifndef __paco_mpcircuit_h_
#define __paco_mpcircuit_h_

#include "paco_com.h"
#include <Padico/MPCircuit.h>

class paco_mpcircuit : public paco_com
{
 public:
  paco_mpcircuit(void * group);
  ~paco_mpcircuit();

  int paco_rank(int  * rank);
  int paco_barrier();

  //  void paco_group(padico_mpcircuit_t group);
  int paco_bcast(void* buf, int count, int root);

 protected:
  padico_mpcircuit_t my_group_id;
};

class paco_mpcircuit_fabrique : public paco_fabrique_com {
public:
  paco_com* paco_create(void* group) {
    return new paco_mpcircuit(group);
  }
};
#endif
